> For the complete documentation index, see [llms.txt](https://developers.oxylabs.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.oxylabs.io/products/web-scraper-api/features/http-context-and-job-management/headers-cookies-method.md).

# Headers, Cookies, Method

Web Scraper API maximizes website access efficiency by using headers and cookies predefined by our team. If needed, you can define your own headers, cookies, and the HTTP method.

## Custom headers

If you require your own headers, you can use them by adding the `context:force_headers` parameter and setting it to `true` when submitting a scraping job. Web Scraper API will send your custom headers together with the predefined headers set and then use them to access the website.

#### Code example

```json
{
    "context": [
        {
            "key": "force_headers",
            "value": true
        },
        {
            "key": "headers",
            "value": {
                "Accept-Language": "en-US,en;q=0.5"
            }
        }
    ]
    "source": "universal",
    "url": "https://example.com",
}
```

## Custom cookies

If you require your own cookies, you can use them by adding the `context:force_cookies` parameter and setting it to `true` when submitting a scraping job. Web Scraper API will send your custom cookies together with the predefined cookies set and then use them to access the website. If you  also want to reuse the same proxy IP address, check out the [proxy sessions](/products/web-scraper-api/features/localization/proxy-location.md#sessions) documentation.

#### Code example

```json
{
    "context": [
        {
            "key": "force_cookies",
            "value": true
        },
        {
            "key": "cookies",
            "value": [
                {
                    "key": "NID", 
                    "value": "1234567890"
                }
            ]
        },
    ],
    "source": "universal",
    "url": "https://example.com",
}
```

## HTTP Method

`universal` source uses the `GET` HTTP method by default.

If you need to post data to the target website, you must set the HTTP method to `POST` and provide a Base64-encoded `POST` request body.

**Code example**

```json
[
    {
        "key": "http_method",
        "value": "post"
    },
    {
        "key": "content",
        "value": "base64EncodedPOSTBody"
    }
]
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.oxylabs.io/products/web-scraper-api/features/http-context-and-job-management/headers-cookies-method.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
